#!/usr/bin/env python
# -*- coding: UTF-8 -*-
u"""
utilitaire d'instanciation ligne de commande de fichiers templates à partir d'un dictionnaire xml

usage::

    %prog -x <path>/eole.xml -o <path>/test.txt -i <path>/dico.eol testtemplate.tmpl

testtemplate est le fichier à instancier

"""
import sys
import os.path as osp
from optparse import OptionParser
from creole.creolecat import instance

def parse_cmdline():
    parser = OptionParser(usage=__doc__)
    parser.add_option("-x", "--xml", dest="xmlfile", default=None,
                  help=u"dictionnaire xml (facultatif)", metavar="XMLFILE")

    parser.add_option("-o", "--output", dest="outputfile",
                  help=u"fichier généré", metavar="OUTPUTFILE")

    parser.add_option("-i", "--input", dest="inifile",
                  help=u"fichier de valeurs (.eol)", metavar="INPUTTFILE")

    (options, args) = parser.parse_args()

    if not options.outputfile:
        parser.error("il faut un nom de fichier de sortie")

    if not len(args) == 1:
        parser.error("il faut un et un seul fichier de template")

    if args[0] == options.outputfile:
        parser.error("il faut un nom de fichier different")

    return options, args

def parse():
    options, args = parse_cmdline()
    inputfile = args[0]
    xmlfile = options.xmlfile
    outputfile = options.outputfile
    inifile = options.inifile
    return inputfile, xmlfile, outputfile, inifile

def main():
    instance(*parse())

if __name__ == '__main__':
    main()
